/*
 * Cell.cpp
 *
 *  Created on: Jan 31, 2013
 *      Author: perepelkin
 */

#include "Cell.h"

#include <assert.h>
const CELL_STATE Cell::c_Move_mask=0x0F;
const CELL_STATE Cell::c_Rest_particles_mask=0xF0;

Cell::Cell(CELL_STATE state)
	: State(state)
{
}

/*
unsigned char Cell::getRestMass() const
{
	return (State>>4)*2;
}
*/

unsigned char Cell::getMoveMass() const
{
	char s = State & c_Move_mask;
	unsigned char result = 0;
	while(s>0)
	{
		result += s&1;
		s >>= 1;
	}
	return result;
}

unsigned char Cell::getMass() const
{
	return getRestMass() + getMoveMass();
}

unsigned char Cell::getImpulse() const
{
	Cell result(State);

	result.setRestMass(0);

	if(result.getRight() && result.getLeft())
	{
		result.setRight(false);
		result.setLeft(false);
	}

	if(result.getUp() && result.getDown())
	{
		result.setUp(false);
		result.setDown(false);
	}

	return result.State;
}

/*
bool Cell::getRight() const { return State & 0x01; }
bool Cell::getDown() const { return State & 0x02; }
bool Cell::getLeft() const { return State & 0x04; }
bool Cell::getUp() const { return State & 0x08; }
void Cell::setRestMass(size_t rest_mass)
{
	assert(rest_mass%2==0);
	assert(rest_mass<=30);

	rest_mass = (rest_mass/2) << 4;
	State &= 0x0F;
	State += rest_mass;
}

void Cell::setRight(bool particle)
{
	if(particle)
		State |= 0x01;
	else
		State &= ~(0x01);
}

void Cell::setDown(bool particle)
{
	if(particle)
		State |= 0x02;
	else
		State &= ~(0x02);
}

void Cell::setLeft(bool particle)
{
	if(particle)
		State |= 0x04;
	else
		State &= ~(0x04);
}

void Cell::setUp(bool particle)
{
	if(particle)
		State |= 0x08;
	else
		State &= ~(0x08);
}
*/
bool Cell::operator==(const Cell& c) const
{
	return State==c.State;
}

bool Cell::operator!=(const Cell& c) const
{
	return !(*this == c);
}

