/*
 * Field.cpp
 *
 *  Created on: Jan 31, 2013
 *      Author: perepelkin
 */

#include "Field.h"

#include <iostream>
#include <assert.h>

Field::Field(size_t width, size_t height)
{
	if(width==0 || height==0)
		throw Exception();

	Width = width;
	Height = height;

	Cells = new Cell[Width*Height];
}

Field::Field(size_t width, size_t height, Cell(*init_func)(uint,uint,size_t,size_t))
{
	if(width==0 || height==0)
		throw Exception();

	Width = width;
	Height = height;

	Cells = new Cell[Width*Height];

	for(uint row=0; row<Height; row++)
		for(uint col=0; col<Width; col++)
			at(col, row) = init_func(col, row, width, height);
}

Field::~Field()
{
	delete [] Cells;
}

size_t Field::getWidth() const
{
	return Width;
}

size_t Field::getHeight() const
{
	return Height;
}

/*
inline const Cell& Field::at(uint col, uint row) const
{
	assert(row<Height && col<Width);
	return Cells[row*Width+col];
}

inline Cell& Field::at(uint col, uint row)
{
	assert(row<Height && col<Width);
	return Cells[row*Width+col];
}
const Cell& Field::getCellPeriodic(int col, int row) const
{
	uint ucol, urow;

	if(col >= 0)
		ucol = col % Width;
	else
		ucol = (Width - (-col)%Width)%Width;

	if(row >= 0)
		urow = row % Height;
	else
		urow = (Height - (-row)%Height)%Height;

	return at(ucol, urow);
}
*/














