/*
 * Field.h
 *
 *  Created on: Jan 31, 2013
 *      Author: perepelkin
 */

#ifndef FIELD_H_
#define FIELD_H_

#include "Cell.h"

#include <stdlib.h>

typedef float(*ConverterFunc)(const Cell&);

class Field
{
	size_t Width, Height;
	Cell* Cells;
public:
	class Exception {};
	Field(size_t width, size_t height);
	Field(size_t width, size_t height,
			Cell(*init_func)(uint col, uint row, size_t width, size_t height));
	virtual ~Field();

	size_t getWidth() const;
	size_t getHeight() const;

	inline const Cell& at(uint col, uint row) const { return Cells[col+row*Width]; }
	inline Cell& at(uint col, uint row) { return Cells[col+row*Width]; }

inline const Cell& getCellPeriodic(int col, int row) const
{
	uint ucol, urow;

	if(col >= 0)
		ucol = col % Width;
	else
		ucol = (Width - (-col)%Width)%Width;

	if(row >= 0)
		urow = row % Height;
	else
		urow = (Height - (-row)%Height)%Height;

	return at(ucol, urow);
}

private:
};



#endif /* FIELD_H_ */
