/*
 * NormalProcessor.h
 *
 *  Created on: Feb 4, 2013
 *      Author: perepelkin
 */

#ifndef NORMALPROCESSOR_H_
#define NORMALPROCESSOR_H_

#include <string>
#include <assert.h>
#include "Processor.h"
#include "Rectangle.h"

class NormalProcessor : public Processor
{
	//std::map<int, std::vector<std::pair<float, int> > > Transitions;
	std::vector<std::pair<float, int> > *Transitions;
	unsigned int EndState;
	Rectangle Area;
	bool CheckProbabilities;
	size_t *RulesLog;
	std::string SaveTablePath;
public:
	bool NoRPCreate;
	NormalProcessor(unsigned int end_state, Rectangle area, bool check_probs, const std::string& save_table, bool no_rp_create);
	~NormalProcessor();

	void process(const Field& source, Field& destination, int, int thread_rank, size_t threads_count);

private:

	inline static void shiftRule(const Cell& middle, const Cell& right, const Cell& down, const Cell& left, const Cell& up, Cell& result)
{
	result.setRestMass(middle.getRestMass());
	result.setRight(left.getRight());
	result.setDown(up.getDown());
	result.setLeft(right.getLeft());
	result.setUp(down.getUp());
}

	inline CELL_STATE collapseRule(const Cell& c)
{
	int index = c.State;
	assert(index < EndState);

	if(Transitions[index].empty())
		return c.State;

	//int count = 1+Transitions[index].size();

	double r = rand()%100000/100000.0;

	unsigned int candidate=0;
	while(r>Transitions[index][candidate].first && candidate<Transitions[index].size())
	{
		r -= Transitions[index][candidate].first;
		candidate++;
	}

	if(candidate < Transitions[index].size())
		return Transitions[index][candidate].second;
	else
		return c.State;
}


	friend void test_NormalProcessor_shiftRule();
	friend class BoundaryProcessor;
	friend class RulesTableProcessor;
};

#endif /* NORMALPROCESSOR_H_ */
