/*
 * RulesTableProcessor.h
 *
 *  Created on: Feb 20, 2013
 *      Author: perepelkin
 */

#ifndef RULESTABLEPROCESSOR_H_
#define RULESTABLEPROCESSOR_H_

#include <string>
#include <assert.h>
#include "Processor.h"
#include "Rectangle.h"

class RulesTableProcessor : public Processor
{
	std::vector<std::pair<float, int> >  *Transitions;
	Rectangle Area;
	size_t EndState;
public:
	RulesTableProcessor(const std::string& file, Rectangle area, size_t end_state);
	~RulesTableProcessor();

	void process(const Field& source, Field& destination, int, int thread_rank, size_t threads_count);

	inline CELL_STATE collapseRule(const Cell& c)
{
	assert(c.State < EndState);
	int index = c.State;

	if(Transitions[index].empty())
		return c.State;

	double r = rand()%100000/100000.0;

	unsigned int candidate=0;
	while(r>Transitions[index][candidate].first && candidate<Transitions[index].size())
	{
		r -= Transitions[index][candidate].first;
		candidate++;
	}

	if(candidate < Transitions[index].size())
		return Transitions[index][candidate].second;
	else
		return c.State;
}

};

#endif /* RULESTABLEPROCESSOR_H_ */
