/*
 * SourceProcessor.h
 *
 *  Created on: Feb 4, 2013
 *      Author: perepelkin
 */

#ifndef SOURCEPROCESSOR_H_
#define SOURCEPROCESSOR_H_

#include "Processor.h"
#include "Rectangle.h"

class SourceProcessor: public Processor
{
	Rectangle Area;
	std::vector<std::pair<int, int> > Intervals;
	std::vector<std::pair<float, int> > States;
public:
	SourceProcessor(
			Rectangle area, 
			const std::vector<std::pair<float, int> >& states, 
			const std::vector<std::pair<int, int> >& intervals)
{ Area = area; States = states; Intervals = intervals; }

	virtual void process(const Field&, Field&, int, int, size_t);
};

class CircleSourceProcessor: public Processor
{
	unsigned int X, Y, R;
	std::vector<std::pair<int, int> > Intervals;
	std::vector<std::pair<float, int> > States;
public:
	CircleSourceProcessor(
			int x, int y, int r,
			const std::vector<std::pair<float, int> >& states, 
			const std::vector<std::pair<int, int> >& intervals)
{ X=x; Y=y; R=r; States = states; Intervals = intervals; }

	virtual void process(const Field&, Field&, int, int, size_t);
};

class RandomSourceProcessor : public Processor
{
	Rectangle Area;
	std::vector<std::pair<int, int> > Intervals;
	int EndState;
public:
	RandomSourceProcessor(
			Rectangle area, 
			int end_state, 
			const std::vector<std::pair<int, int> >& intervals)
{ Area = area; EndState = end_state; Intervals = intervals; }

	virtual void process(const Field&, Field&, int, int, size_t);
};

#endif /* SOURCEPROCESSOR_H_ */
